/*
 * adc.c
 *
 *  Created on: 2020831
 *      Author: Yeguanyong
 */
#include "adc.h"
#include "sci_fifo.h"
#include "string.h"

//volatile unsigned char adc_com_flag;			/* adcתɽжȥƽֵ־λ */
volatile static unsigned int dma_adcbuf[BUF_SIZE];		/* adcݻ */
volatile static unsigned int dma_adcbuf_end[8];		/* ADCƽֵŻ */
volatile unsigned int dma_adcbuf_enduse[8];		/* ADCƽֵŻ */


/**
*@ Description:adc
* @param .
* @return 
*/
static void adc_config(void)
{

	EALLOW;
	SysCtrlRegs.HISPCP.all = ADC_MODCLK;		// 150 / (2*3) = 20M
	EDIS;

	InitAdc();
    AdcRegs.ADCTRL1.bit.ACQ_PS = ADC_SHCLK;
	AdcRegs.ADCTRL1.bit.CPS = 1;
    AdcRegs.ADCTRL3.bit.ADCCLKPS = ADC_CKPS;
    AdcRegs.ADCTRL1.bit.SEQ_CASC = 1;       // 0 Non-Cascaded Mode

    AdcRegs.ADCTRL2.bit.INT_ENA_SEQ1 = 0x1;
    AdcRegs.ADCTRL2.bit.RST_SEQ1 = 0x1;
    AdcRegs.ADCCHSELSEQ1.bit.CONV00 = 0x0;  //ѡܽADCINA0
    AdcRegs.ADCCHSELSEQ1.bit.CONV01 = 0x1;  //ADCINA1
    AdcRegs.ADCCHSELSEQ1.bit.CONV02 = 0x2;  //ADCINB0
    AdcRegs.ADCCHSELSEQ1.bit.CONV03 = 0x3;  //ADCINB1
    AdcRegs.ADCCHSELSEQ2.bit.CONV04 = 0x4;
    AdcRegs.ADCCHSELSEQ2.bit.CONV05 = 0x5;
    AdcRegs.ADCCHSELSEQ2.bit.CONV06 = 0x6;
    AdcRegs.ADCCHSELSEQ2.bit.CONV07 = 0x7;
    AdcRegs.ADCMAXCONV.bit.MAX_CONV1 = 7;   // Set up ADC to perform 4 conversions for every SOC

	//AdcRegs.ADCTRL1.bit.CPS			= 1;
    AdcRegs.ADCTRL1.bit.CONT_RUN = 1;        //ģʽ
    AdcRegs.ADCTRL1.bit.SEQ_OVRD = 1;       // Enable Sequencer override feature
//    AdcRegs.ADCCHSELSEQ1.all = 0x0;         // Initialize all ADC channel selects to A0
//	AdcRegs.ADCCHSELSEQ2.all = 0x0;
//	AdcRegs.ADCCHSELSEQ3.all = 0x0;
//	AdcRegs.ADCCHSELSEQ4.all = 0x0;
}

/**
*@ Description:ADCҪDMAʼ
* @param .
* @return 
*/
static void adc_dmaconfig(void)
{
	volatile unsigned int *dmadest;
	volatile unsigned int *dmasource;
	DMAInitialize();

	memset((void *)dma_adcbuf, 0, sizeof(dma_adcbuf));
	memset((void *)dma_adcbuf_end, 0, sizeof(dma_adcbuf_end));

	dmadest = dma_adcbuf;
	dmasource = &AdcMirror.ADCRESULT0;    //Point DMA source to ADC result register base
	DMACH1AddrConfig(dmadest, dmasource);
	/*
	 * ADCһSOCԲɼ8ͨA0~A7
	 * 1.bsize = 7ʾһ֡7+1=8(WORD)
	 * 2.srcbstep = 1ʾÿWORDɺԴַƫ+1
	 * 		ʵADCRESULT0ƫ1ADCRESULT1
	 * 3.desbstep = 10ʾÿWORDɺĿĵַƫ+10
	 * */
	DMACH1BurstConfig(7, 1, 10);
	/* 1.tsize = 9ʾÿ 9+1 = 10 ֡жһΡ
	 * 2.srctstep = 1ʾÿһ֡ǰһ֡Դַƫ+1
	 * 		ʵpDMASourceADCRESULT0ƫƵADCRESULT7
	 * 3.deststep = 0
	 * */
	DMACH1TransferConfig(9, 1, 0);
	/*
	 * ĸֱSRC_WRAP_SIZESRC_WRAP_STEPDST_WRAP_SIZEDST_WRAP_STEP
	 * ÿ2burstԺԴַصʼλãBurstöӦ4ͨÿת2Σ
	 * ÿ1burstĿĵַΪʼַ+1ָDMABuf1һԪ
	 * */
	DMACH1WrapConfig(0, 0, 0, 1);

	DMACH1ModeConfig(DMA_SEQ1INT, PERINT_ENABLE,
					 ONESHOT_DISABLE, CONT_DISABLE,
					 SYNC_DISABLE, SYNC_SRC,
	                 OVRFLOW_DISABLE, SIXTEEN_BIT,
	                 CHINT_END, CHINT_ENABLE);

	StartDMACH1();

}

/**
*@ Description:ʼADCа
* @param .
* @return 
*/
void adc_init(void)
{
	//adc_com_flag = 0;
	EALLOW;
	PieVectTable.DINTCH1 = &dma_adc_isr;
	EDIS;

	IER |= M_INT7;
	EnableInterrupts();

	adc_config();
	adc_dmaconfig();

	memset((void *)dma_adcbuf_end, 0, sizeof(dma_adcbuf_end));

	// Start SEQ1
	AdcRegs.ADCTRL2.bit.SOC_SEQ1 = 0x1;
}

/**
*@ Description:DMAһνʼжϺ
* @param .
* @return 
*/
/*
 * תתһȦһڣ40usĸתٵһڣ*40
 * */
__interrupt void dma_adc_isr(void)     // DMA Channel 1
{
	unsigned char i = 0, j = 0;
	for (i = 0; i < 8; i++)
	{
		for (j = 0; j < 10; j++)
		{
			dma_adcbuf_end[i] += dma_adcbuf[j + i * 10];	/* ȡADCֵ */
		}
		dma_adcbuf_end[i] /= 10;			/* ƽֵ */
	}
	memcpy((void *)dma_adcbuf_enduse, (void *)dma_adcbuf_end, 8);
	memset((void *)dma_adcbuf_end, 0, sizeof(dma_adcbuf_end));
	StartDMACH1();
    PieCtrlRegs.PIEACK.all = PIEACK_GROUP7;	
}


