/*
 * adc.h
 *
 *  Created on: 2020831
 *      Author: Yeguanyong
 */

#ifndef BSP_ADC_H_
#define BSP_ADC_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "DSP2833x_Device.h"     // Headerfile Include File
#include "DSP2833x_Examples.h"   // Examples Include File

#define ADC_MODCLK 0x3 		// HSPCLK = SYSCLKOUT/2*ADC_MODCLK2 = 120/(2*3)   = 20.0 MHz
#define ADC_CKPS   0xF  		// ADC module clock = HSPCLK/2*ADC_CKPS   = 20.0MHz/(1*2) = 12.5MHz
#define ADC_SHCLK  0xf   		// S/H width in ADC module periods = 16 ADC clocks
#define BUF_SIZE   80   	// Sample buffer size

extern volatile unsigned int dma_adcbuf_enduse[8];

extern void adc_init(void);
extern __interrupt void dma_adc_isr(void);

#ifdef __cplusplus
}
#endif /* extern "C" */


#endif /* BSP_ADC_ADC_H_ */
